#define	SOLARIS	(defined(sun) && (defined(__SVR4) || defined(__svr4__)))

#include "config.h"
#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <sys/time.h>
#include <sys/syslog.h>
#include <sys/socket.h>
#include <sys/un.h>
#ifdef HAVE_SYS_FILIO_H
#include <sys/filio.h>
#endif
#include <netinet/in.h>
#include <arpa/nameser.h>
#include <arpa/inet.h>

#include <utmp.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <dirent.h>
#include <assert.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#ifdef  __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include <stdio.h>
#include <errno.h>
#include <netdb.h>
#include <resolv.h>
#include <signal.h>
#ifdef	HAVE_SSL_H
#include "ssl.h"
#include "bio.h"
#endif

#ifndef	__P
# ifdef __STDC__
#  define	__P(x)	(x)
# else
#  define	__P(x)	()
# endif
#endif
#ifndef __STDC__
# undef		const
# define	const
#endif

#ifndef MIN
# define	MIN(a,b)	((a) < (b) ? (a) : (b))
#endif

#include "buflist.h"

#if !defined(HAVE_REGEX_T)
typedef char * regex_t;
#endif

#if !defined(HAVE_REGCOMP) && defined(REGEX_BUILD)
#define	INIT		register char *sp = instring;
#define	GETC()		(*sp++)
#define	PEEKC()		(*sp)
#define	UNGETC(c)	(--sp)
#define	RETURN(c)	return;
#define	ERROR(c)	regerr(c)

#include <regexp.h>
#endif

#ifdef	HAVE_REGCOMP
#include <regex.h>
#endif

extern	void	syserr __P((char *, ...));
extern	int	yyparse __P((void));

#ifndef	LOG_AUTHPRIV
#define	LOG_AUTHPRIV	(10<<3)	/* audit daemon */
#endif
#ifndef	LOG_FTP
#define	LOG_FTP		(11<<3)	/* audit daemon */
#endif
#ifndef	LOG_AUDIT
#define	LOG_AUDIT	(13<<3)	/* audit daemon */
#endif
#ifndef	LOG_LFMT
#define	LOG_LFMT	(14<<3)	/* logalert daemon */
#endif
#ifndef	LOG_MAKEPRI
#define	LOG_MAKEPRI(fac, pri)	(((fac) << 3) | (pri))
#endif
#ifndef	LOG_MARK
#define	LOG_MARK	LOG_MAKEPRI(LOG_NFACILITIES, 0)
#endif
#ifndef	LOG_PRI
#define LOG_PRI(p)	((p) & LOG_PRIMASK)
#endif
#if LOG_CRON == (9<<3)
#define	LOG_CRON1	LOG_CRON
#define	LOG_CRON2	(15<<3)
#endif
#if LOG_CRON == (15<<3)
#define	LOG_CRON1	(9<<3)
#define	LOG_CRON2	LOG_CRON
#endif


/*
 * Combine both sockaddr_in and sockaddr_un into a single type.
 */
union un_sockaddr {
	struct sockaddr_in s_in;
	struct sockaddr_un s_un;
};


/*
 *
 */
#define	MAX_NIOV	6

#undef	_assert
#undef	assert
#define	assert	_assert
#define	_assert(ex)	{if (!(ex)){(void)fprintf(stderr,"Assertion failed: file \"%s\", line %d\n", __FILE__, __LINE__);abort();}}

