#define	HASH_WRITE_INTERVAL	600
#define	HASH_H0_EXT	".H0"
#define	MAC_SIZE	20

typedef	struct	htable	{
	char *ht_name;
	char *ht_ext;
	int ht_type;
} htable_t;

#define	HASH_NONE	0
#define	HASH_DEFAULT	HASH_NONE
#define	HASH_SHA_1	1

#define	HASH_SALT_BITS	128
#define	HASH_SALT_SZ	(HASH_SALT_BITS/8)	
#define	HASH_RANDOM	"/dev/random"
#define	HASH_LOGDIR	"/var/log/hash"
#define	HASH_REHASHTIME	2	/* length of time to rehash seed for */


typedef	struct	hashrec {
	char	hr_mac[MAC_SIZE];
	time_t	hr_when;
	int	hr_pri;		/* message priority */
	u_long	hr_cnts[3];	/* hash counters */
} hashrec_t;

#define	hr_hcnt	hr_cnts[0]	/* hash count */
#define	hr_lcnt	hr_cnts[1]	/* syslog line count */
#define	hr_fcnt	hr_cnts[2]	/* file count */


typedef	struct	hashtype {
	int	ht_type;
	char	*ht_name;
	void	*ht_buf;
	void	*ht_digest;
	struct	htable *ht_tab;
	size_t	ht_dsize;
	void	(* ht_create) __P((struct hashtype *));
	void	(* ht_destroy) __P((struct hashtype *));
	void	(* ht_init) __P((void *));
	void	(* ht_update) __P((void *, char *, size_t));
	void	(* ht_final) __P((char *, void *));
} hashtype_t;


struct logmsgtype;
struct filespec;

extern	hashtype_t	*hash_initfile __P((int));
extern	void		hash_initpass __P((int));
extern	void		hash_addrec __P((struct logmsgtype *,
					 struct filetype *, struct iovec *,
					 int));
extern	int		hash_openH0 __P((char *, char *, int));
extern	void		hash_writeH0 __P((hashtype_t *, char *, char *,
					  u_long *, size_t));
extern	void		hash_flush __P((void));
extern	htable_t	*hash_lookup __P((char *));
extern	hashtype_t	*hash_find __P((int));
extern	char		*hash_getsalt __P((char *, size_t));
extern	void		hash_savesalt __P((char *, char *, size_t));
extern	hashtype_t	*hash_get __P((int));
extern	hashtype_t	*hash_getnext __P((int));
extern	int		htcp_action __P((netspec_t *));

extern	void	hash_init __P((hashtype_t *));
extern	void	hash_update __P((hashtype_t *, char *, size_t));
extern	char	*hash_final __P((hashtype_t *, char *));
extern	int	hash_openfile __P((char *, char *, char *, char *,
				   hashtype_t *));

