
typedef	struct	htcpcmd	{
	u_short	hth_cmd;
	u_short	hth_op;
} htcpcmd_t;

/* hth_cmd - commands */
#define	HTC_NULL	0x0000
#define	HTC_HASH_FN	0x0001
#define	HTC_CRYPT_FN	0x0002
#define	HTC_NONCE	0x0003
#define	HTC_HASH	0x0004
#define	HTC_MSG		0x0005
#define	HTC_MHASH	0x0006
#define	HTC_H0		0x0007
#define	HTC_SSL		0x0008
#define	HTC_CMDMSK	0x00ff

#define	HTC_VARLEN	0x2000
#define	HTC_ACK		0x4000
#define	HTC_ERROR	0x8000

#define	HTC_CMDS	(HTC_CMDMSK|HTC_ACK|HTC_ERROR)
#define	HTC_CMD(x)	((x) & HTC_CMDS)
#define	HTC_ISVARSZ(x)	((x) & HTC_VARLEN)

/*
 * operand values for hth_op
 */
#define	HTCE_UNDEF	0x0000	/* no more error info */
#define	HTCE_BADCMD	0x0001	/* wrong command for this state */

/*
 * hashing algorithms implemented within this package.
 */
#define	HTCH_NONE	0x0000		/* 16 bit two's complement */
#define	HTCH_SHA1_128	HASH_SHA_1	/* standard 32bit CRC */

/*
 * Cryptographic algorithms implemented within this package
 */
#define	HTCC_NONE	0x0000	/* No cryptographic function */
#if 0
#define	HTCC_DES	0x0003	/* 56bit DES */
#define	HTCC_3DES	0x0004	/* triple DES */
#define	HTCC_IDEA	0x0005	/* 128bit IDEA */
#define	HTCC_TWOFISH	0x0006	/* twofish */
#endif

/*
 * States for the internal state machine.
 */
#define	HTCS_SENDING	0
#define	HTCS_HASH_FN	1
#define	HTCS_HASH_ACK	2
#define	HTCS_CRYPT_FN	3
#define	HTCS_CRYPT_ACK	4
#define	HTCS_NONCE_S	5
#define	HTCS_NONCE_D	6
#define	HTCS_HASH_S	7
#define	HTCS_HASH_D	8
#define	HTCS_SSL_C	9	/* SSL_connect side */
#define	HTCS_SSL_A	10	/* SSL_accept side */
#define	HTCS_MSG	11

#define	HTCS_MAX	11
#define	HTCS_NUM	HTCS_MAX + 1

extern int htcp_getmsg __P((netspec_t *, tcplmsg_t *, char *, size_t));

