#define	REGEX_BUILD
#include "h.h"
#include "nsyslog.h"
#include "var.h"
#include "hash.h"
#include "y.tab.h"


#if !defined(lint)
static const char rcsid[] = "$Id: match.c,v 1.8 1999/05/10 18:18:46 darrenr Exp $";
#endif

typedef struct matchspec {
	struct matchspec *ms_next;
	int ms_cnt;
	char *ms_match;
	regex_t ms_buf;
	int ms_not;
} matchspec_t;


int match_inccnt __P((void *, int));
void match_print __P((void *));
void match_expire __P((void));
int match_match __P((void *, logmsgtype_t *));

static	matchspec_t	*mslist = NULL;
vartype_t	matchtype = {
	NULL,		/* next */
	NULL,		/* ptr */
	FIL_MATCH,	/* stype */
	0,		/* dtype */
	"match",	/* name */
	NULL,		/* init */
	NULL,		/* read */
	NULL,		/* readnext */
	NULL,		/* write */
	NULL,		/* link */
	match_match,	/* match */
	NULL,		/* accept */
	NULL,		/* reopen */
	NULL,		/* logmsg */
	match_print,	/* print */
	NULL,		/* fd */
	match_inccnt,	/* inccnt */
	NULL,		/* drain */
	match_expire,	/* expire */
	NULL,	/* expireold */
	NULL,		/* more */
};


matchspec_t *
match_find(parm)
	char *parm;
{
	matchspec_t *ms;

	for (ms = mslist; ms; ms = ms->ms_next)
		if (!strcmp(ms->ms_match, parm))
			return ms;
	return NULL;
}


int
match_match(ptr, lmp)
	void *ptr;
	logmsgtype_t *lmp;
{
	matchspec_t *ms;
	int ok;

	ms = ptr;
	ok = ms->ms_not;
#ifdef	HAVE_REGCOMP
	if (regexec(&ms->ms_buf, lmp->lm_line, 0, NULL, 0))
#else
	if (!step(lmp->lm_line, ms->ms_buf))
#endif
		return !ok;
	return ok;
}


matchspec_t *
match_new(parm)
	char *parm;
{
	matchspec_t *ms;
	int len, not;

	not = get_not();

	if ((ms = match_find(parm)))
		return ms;

	if (!(NEW(ms, NEW_MATCHS)))
		return NULL;
	len = strlen(parm);
	len = len * 2 + 1024;
#ifdef	HAVE_REGCOMP
	(void) regcomp(&ms->ms_buf, parm, REGCOMP_FLAGS);
#else
	ms->ms_buf = (char *)malloc(len);
	(void) compile(parm, ms->ms_buf, ms->ms_buf + len, '\0');
#endif
	ms->ms_match = strdup(parm);
	ms->ms_next = mslist;
	ms->ms_not = not;
	ms->ms_cnt = 0;
	mslist = ms;
	return ms;
}


void
match_expire()
{
	matchspec_t	*ms;

	while ((ms = mslist)) {
		assert(ms->ms_cnt == 0);
		mslist = ms->ms_next;
#ifdef	HAVE_REGCOMP
		regfree(&ms->ms_buf);
#else
		if (ms->ms_buf)
			free(ms->ms_buf);
#endif
		free(ms->ms_match);
		free(ms);
	}
}


int
match_inccnt(ptr, inc)
	void *ptr;
	int inc;
{
	matchspec_t *ms;

	ms = ptr;
	ms->ms_cnt += inc;
	return ms->ms_cnt;
}


void
match_print(ptr)
	void *ptr;
{
	matchspec_t *ms;

	ms = ptr;
	print_not(ms->ms_not);
	printf(" match %s ", ms->ms_match);
}
