#include "h.h"
#include "nsyslog.h"
#include "var.h"
#include "hash.h"
#include "y.tab.h"


#if !defined(lint)
static const char rcsid[] = "$Id: matchprog.c,v 1.7 1999/05/10 18:18:47 darrenr Exp $";
#endif


typedef struct  matchprogspec   {
	struct matchprogspec *mp_next;
	int mp_cnt;
	char *mp_prog;
	int mp_not;
} matchprogspec_t;


int matchprog_inccnt __P((void *, int));
void matchprog_print __P((void *));
void matchprog_expire __P((void));
int matchprog_match __P((void *, logmsgtype_t *));

static	matchprogspec_t	*mpslist = NULL;
vartype_t	matchprogtype = {
	NULL,		/* next */
	NULL,		/* ptr */
	FIL_MATCHPROG,	/* stype */
	0,		/* dtype */
	"match-prog",	/* name */
	NULL,		/* init */
	NULL,		/* read */
	NULL,		/* readnext */
	NULL,		/* write */
	NULL,		/* link */
	matchprog_match,/* match */
	NULL,		/* accept */
	NULL,		/* reopen */
	NULL,		/* logmsg */
	matchprog_print,/* print */
	NULL,		/* fd */
	matchprog_inccnt,/* inccnt */
	NULL,		/* drain */
	matchprog_expire,/* expire */
	NULL,	/* expireold */
	NULL,		/* more */
};


matchprogspec_t *
matchprog_find(parm)
	char *parm;
{
	matchprogspec_t *mp;

	for (mp = mpslist; mp; mp = mp->mp_next)
		if (!strcmp(mp->mp_prog, parm))
			return mp;
	return NULL;
}


int
matchprog_match(ptr, lmp)
	void *ptr;
	logmsgtype_t *lmp;
{
	matchprogspec_t *mp;
	int ok;

	mp = ptr;
	ok = mp->mp_not;
	if ((lmp->lm_prog == NULL) || strcmp(mp->mp_prog, lmp->lm_prog))
		return !ok;
	return ok;
}


matchprogspec_t *
matchprog_new(parm)
	char *parm;
{
	matchprogspec_t *mp;
	int len, not;

	not = get_not();

	if ((mp = matchprog_find(parm)))
		return mp;

	if (!(NEW(mp, NEW_MATCHPS)))
		return NULL;
	len = strlen(parm);
	len *= 2;
	mp->mp_prog = strdup(parm);
	mp->mp_next = mpslist;
	mp->mp_not = not;
	mp->mp_cnt = 0;
	mpslist = mp;
	return mp;
}


void
matchprog_expire()
{
	matchprogspec_t	*mps;

	while ((mps = mpslist)) {
		assert(mps->mp_cnt == 0);
		mpslist = mps->mp_next;
		free(mps->mp_prog);
		free(mps);
	}
}


int
matchprog_inccnt(ptr, inc)
	void *ptr;
	int inc;
{
	matchprogspec_t *mp;

	mp = ptr;
	mp->mp_cnt += inc;
	return mp->mp_cnt;
}


void
matchprog_print(ptr)
	void *ptr;
{
	matchprogspec_t *mp;

	mp = ptr;
	print_not(mp->mp_not);
	printf(" match-prog %s ", mp->mp_prog);
}
