
#include "h.h"
#include "nsyslog.h"
#include "var.h"

extern	vartype_t	filetype;
extern	vartype_t	udptype;
extern	vartype_t	tcptype;
extern	vartype_t	cmdtype;
extern	vartype_t	unixtype;
extern	vartype_t	usertype;
extern	vartype_t	filetype;
extern	vartype_t	factype;
extern	vartype_t	pritype;
extern	vartype_t	facpritype;
extern	vartype_t	matchtype;
extern	vartype_t	matchfiletype;
extern	vartype_t	matchprogtype;
extern	vartype_t	nmasktype;
#if defined(HAVE_GETMSG) && defined(HAVE_SYS_STRLOG_H)
extern	vartype_t	streamtype;
#endif
#ifdef	HAVE_DOOR_H
extern	vartype_t	doortype;
#endif


vartype_t	*vtypes[] = {
	&filetype,
	&udptype,
	&tcptype,
	&cmdtype,
	&unixtype,
	&usertype,
	&filetype,
	&factype,
	&pritype,
	&facpritype,
	&matchtype,
	&matchfiletype,
	&matchprogtype,
	&nmasktype
#if defined(HAVE_GETMSG) && defined(HAVE_SYS_STRLOG_H)
	, &streamtype
#endif
#ifdef	HAVE_DOOR_H
	, &doortype
#endif
};
static	int	ntypes = sizeof(vtypes)/sizeof(vartype_t *);


vartype_t *
type_find(type)
	int type;
{
	vartype_t **v;
	int i;

	type = VAR_TYPE(type);
	i = ntypes;
	for (v = vtypes; i > 0; i--, v++)
		if (VAR_TYPE((*v)->vt_stype) == type ||
		    VAR_TYPE((*v)->vt_dtype) == type)
			return (*v);
	return NULL;
}


vartype_t *
type_lookup(name, type)
	char *name;
	int type;
{
	vartype_t **v;
	int i;

	type = VAR_TYPE(type);
	i = ntypes;
	for (v = vtypes; i > 0; i--, v++)
		if (!strcasecmp((*v)->vt_name, name) &&
		    (VAR_MODE((*v)->vt_stype) == type ||
		     VAR_MODE((*v)->vt_dtype) == type))
			return (*v);
	return NULL;
}


vartype_t *
type_next(ptr)
	void **ptr;
{
	vartype_t **vp;

	vp = *ptr;
	if (vp == NULL) {
		vp = vtypes;
		*ptr = vp;
		return *vp;
	}

	vp++;
	if ((vp - vtypes) >= ntypes) {
		*ptr = NULL;
		return NULL;
	}
	*ptr = vp;
	return *vp;
}
